<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Temporizador</title>
    <link rel="stylesheet" href="style.css">
</head>


<body>

    <table>
        <tr>
            <th>D&nbsp;</th> <!-- el %nbsp; le agega un espacio para que quede mejor centrado -->
            <th>H&nbsp;</th>
            <th>M&nbsp;</th>
            <th>S&nbsp;</th>
        </tr>
        <tr>
            <td id="d"></td>
            <td id="h"></td>
            <td id="m"></td>
            <td id="s"></td>
        </tr>
    </table>

    <script>
        //CREO VARIABLES DE ELEMENTOS DEL TIMER DE LA INTERFAZ
        let s = document.querySelector("#s");
        let m = document.querySelector("#m");
        let h = document.querySelector("#h");
        let d = document.querySelector("#d");
        //VARIABLE PARA EL INTERVALO
        let intervaloDeTiempo;
        //ESTABLEZCO LOS VALORES INICIALES DEL TIMER
        let dias = 1, horas = 0, minutos = 0, segundos = 5;

        //MUESTRO EN LOS ELEMENTOS LOS VALORES INICIALES DEL TIMER
        s.innerHTML = formateaDigitos(segundos);
        m.innerHTML = formateaDigitos(minutos) + ":";
        h.innerHTML = formateaDigitos(horas) + ":";
        d.innerHTML = formateaDigitos(dias) + ":";

        function actualizaTimer() {
            console.log("Ha pasado 1 segundo.");
            //EN ESTA PARTE CREE UN RELOJ NORMAL QUE ARRANCA EN LOS VALORES
            //SEGÚN INICIALIZADOS////////////////////////////////////////////
            // segundos++;
            // if (segundos === 60) {
            //     minutos++;
            //     segundos = 0;
            // }
            // if (minutos === 60) {
            //     horas++;
            //     minutos = 0;
            // }
            // if (horas === 24) {
            //     dias++;
            //     horas = 0;
            // }
            // s.innerHTML = "00".substring(0,2-(segundos+"").length)+segundos;
            // m.innerHTML = "00".substring(0,2-(minutos+"").length)+minutos+":";
            // h.innerHTML = "00".substring(0,2-(horas+"").length)+horas+":";
            // d.innerHTML = "00".substring(0,2-(dias+"").length)+dias+":";
            //AQUÍ SE TERMINA EL RELOJ NORMAL////////////////////////////////////

            //EN ESTA PARTE PROGRAMO UN TEMPORIZADOR QUE ARRANCA EN LOS VALORES
            //SEGÚN INICIALIZACIÓN, DE MODO DESCENDENTE.
            //PRIMERO EVALÚA SEGUNDOS, Y LUEGO SEGUNDOS LLAMA A MINUTOS Y ASÍ...
            evaluaSegundos();

            //A CONTINUACIÓN PREGUNTO SI TODO DA 0 QUIERE DECIR QUE TERMINÓ
            //Y CANCELO EL SETINTERVAL
            if (segundos + minutos + horas + dias === 0) clearInterval(intervaloDeTiempo);
        }

        function evaluaSegundos() {
            if (segundos > 0) {
                segundos--;
                s.innerHTML = formateaDigitos(segundos);
            } else {
                evaluaMinutos();
            }
        }

        function evaluaMinutos() {
            if (minutos > 0) {
                minutos--;
                segundos = 60;
                m.innerHTML = formateaDigitos(minutos) + ":";
                evaluaSegundos();
            } else {
                evaluaHoras();
            }
        }

        function evaluaHoras() {
            if (horas > 0) {
                horas--;
                minutos = 60;
                h.innerHTML = formateaDigitos(horas) + ":";
                evaluaMinutos();
            } else {
                evaluaDias();
            }
        }

        function evaluaDias() {
            if (dias > 0) {
                dias--;
                horas = 24;
                d.innerHTML = formateaDigitos(dias) + ":";
                evaluaHoras();
            }
        }

        //EN LA SIGUIENTE FUNCIÓN, ARMO UNA STRING CON 00 Y CON EL MÉTODO
        //SUBSTRING LE CONCATENO EL VALOR DEL DATO, SEA SEGUNDO, MINUTO, HORA
        //O DÍA. DE LOS DOS CEROS MUESTRO UNO O NINGUNO, SEGÚN SEA LA LONGITUD
        //DEL DATO, POR EJEMPLO SI ES 7 EL VALOR, SU LONGITUD ES 1,
        //POR LO TANTO AL RESTÁRSELO A 2 QUEDARÁ UN CERO Y EL DATO.
        //TIP: DATO + "" LO USO PARA PASAR DATO A STRING, PARA PODER USAR LA PROPIEDAD LENGTH.
        //SI LO DEJO COMO DATO SOLO, ES NUMÉRICO Y NO PUEDO USAR LENGTH
        function formateaDigitos(dato) {
            return "00".substring(0, 2 - (dato + "").length) + dato;
        }

        //ESTA FUNCIÓN LLAMA A ACTUALIZATIMER POR CADA SEGUNDO
        function repetirCadaSegundo() {
            intervaloDeTiempo = setInterval(actualizaTimer, 1000);
        }

        //ÉSTE ES EL LLAMADO A LA FUNCIÓN QUE SE DISPARA PARA INICIAR EL PROCESO
        repetirCadaSegundo();
    </script>
</body>

</html>